// quicksort.h  UNFINISHED
// Glenn G. Chappell
// 12 Dec 2013
//
// For CS 202 Fall 2013
// Header for function template quicksort
// There is no associated source file

#ifndef FILE_QUICKSORT_H_INCLUDED
#define FILE_QUICKSORT_H_INCLUDED


#include <algorithm>
using std::swap;


// partition
// Partitions a sequence about a given pivot. Uses Hoare Algorithm.
// Returns the new pivot position via a reference parameter.
// Requirements on Types:
//     RAIter must be a random-access iterator type.
//     operator< must be a total order on the value type of RAIter.
// Pre:
//     [first, last) is a valid nonempty range.
//     pivotiter is an iterator in the range [first, last).
// Post:
//     [first, last) contains the same items as it did initially, but
//      now each ITEM before pivotiter has !(*pivotiter < ITEM), and
//      each ITEM after pivotiter has !(ITEM < *pivotiter).
//     pivotiter lies in [first, last) and references an item with the
//      same value as *pivotiter before the function call.
template <typename RAIter>
void partition(RAIter first, RAIter last, RAIter & pivotiter)
{
    // Put the pivot at the start of the list
    swap(*first, *pivotiter);

    // Now "first" points to the pivot

    // Iterator left: all items before it have !(PIVOT < ITEM)
    RAIter left = first+1;
    // Iterator right: all items after it have !(ITEM < PIVOT)
    RAIter right = last-1;
    // In the loop below, we stop when items before left + items
    //  after right are the entire list.

    while (left <= right)
    {
        // Move left & right in as far as we can
        if (!(*first < *left))        // if *left <= PIVOT
            ++left;
        else if (!(*right < *first))  // if *right >= PIVOT
            --right;
        // If we can move neither left nor right, then swap their items
        else
        {
            swap(*left, *right);
            ++left;
            --right;
        }
    }

    // Note new pivot position, for caller, and put pivot there
    pivotiter = right;
    swap(*first, *pivotiter);
}


// quicksort
// Given range specifed with two random-access iterators, sorts the
// range, ascending, using "<".
template<typename Iter>
void quicksort(Iter first, Iter last)
{
    size_t size = last - first;

    // WRITE THIS!!!

    // BASE CASE
    
    // RECURSIVE CASE
}


#endif  //#ifndef FILE_QUICKSORT_H_INCLUDED

